#define GUI_Reboot 0
#define GUI_Browser 1
#define GUI_ShowFPS 2
#define GUI_240lines 3
#define GUI_SprLimit 4
#define GUI_Sound 5
#define GUI_SoundQuality 6
#define GUI_SoundFilter 7
#define GUI_VSync 8
#define GUI_VideoMode 9
#define GUI_Fskip 10
#define GUI_Fskipadj 11
#define GUI_Gamma 12
#define GUI_AutoA 13
#define GUI_AutoB 14
#define GUI_Pmode 15
#define GUI_Save 16
#define GUI_Load 17
#define GUI_Reset 18
#define GUI_Return 19

#define MAXL 19
#define NB_LINE_SHOWN 8

int doGUI()
{
	
  static char listeChoix[MAXL+1][64]={
  "Reboot", //0
  "Exit to ROM selector", //1
  "Show fps", //2
  "240 lines", //3
  "2x Sprite Limit", //4  
  "Sound", //5
  "Sound Filter", //6
  "Sound Quality", //7
  "VSync", //8  
  "Video", //9
  "Frameskip", //10
  "Frameskip adj", //11  
  "Gamma", //12
  "Autofire A", //13
  "Autofire B", //14  
  "Pad mode", //15  
  "Save", //16
  "Load", //17
  "Reset",//18
  "Return" //19
  };
  
  static char listeSndQuality[3][5]={"Low","Med","High"};
  static char listeSndFilter[3][5]={"None","Low","High"};
  static char listepadmode[3][4]={"Pl1","Pl2","Zap"};
  static char listeAutoMode[4][5]={"Off","Slow","Med.","Fast"};
  static char listestate[10][3]={"0","1","2","3","4","5","6","7","8","9"};  
  static char listeFskip[11][5]={"0","1","2","3","4","5","6","7","8","9","AUTO"};  
  static char scaleMode[/*5*/2][6]={"Norm.","Fast"};//,"Nice1","Nice2","Nice3"};
  static char listefskipadj[6][4]={"00%","10%","20%","30%","40%","50%"};
  static char helpText[MAXL+1][64]={
  "Press A to reboot GP32", //0
  "Press A to return to browser", //1
  "Select slot and press A",  //2
  "Select slot and press A",  //3
  "Choose a value",  //4
  "When AUTO, fskip adj isn't used.", //5
  "If blinking sprites aren't visible.", //6
  "Double max drawn sprites (16)",  //7
  "Show FPS and speed statistics", //8
  "Choose a value", //9
  "Draw all 240 lines(NTSC only)", //10
  "Choose a video mode", //11
  "On is nicer but slower.", //12
  "Button A autofire",  //13
  "Button B autofire",  //14
  "Choose inputs mapped to buttons",  //15
  "Press A to reset NES", //16
  "Choose a value", //17
  "Choose a value", //18
  "Press A to return to emulation"  //19
  };
  static char messageMatrix[7][64]={"LjGP32","NES","Nintendo","Gamepark","Shatbox","Nester","Little John"};
  int startl,endl;
  
  int choix;
  static int pos=MAXL-1;
  int savestateNb,loadstateNb;
  int ExKey;
  int fc;
  int i,j,k,validate;
  byte *fxbuffer[4];
  int ypos[4];
  char chaine[512];
      
 
  choix=0;  
  loadstateNb=savestateNb=0;
   
  fxbuffer[0]=(byte*)gm_malloc(320*512);
  fxbuffer[1]=(byte*)gm_malloc(320*512);
  fxbuffer[2]=(byte*)gm_malloc(320*512);
  fxbuffer[3]=(byte*)gm_malloc(320*512);
  
  if ( !(fxbuffer[0]&&fxbuffer[1]&&fxbuffer[2]&&fxbuffer[3]) ) 
  {
  	CloseAll();
	GpClockSpeedChange(67800000, 0x69032, 3); 
  	GpAppExit();
  }
  
  gm_memset(fxbuffer[0],0,320*512);
  gm_memset(fxbuffer[1],0,320*512);
  gm_memset(fxbuffer[2],0,320*512);
  gm_memset(fxbuffer[3],0,320*512);
  
  
  ypos[0]=0;
  ypos[1]=0;
  ypos[2]=0;
  ypos[3]=0;
  
  for (i=0;i<127;i++) 
  {  	
    Message((rand()%300)>>3<<3,(rand()%230)>>3<<3,messageMatrix[rand()&7],fxbuffer[0],1);
    Message((rand()%300)>>3<<3,(rand()%230)>>3<<3,messageMatrix[rand()&7],fxbuffer[1],2);
    Message((rand()%300)>>3<<3,(rand()%230)>>3<<3,messageMatrix[rand()&7],fxbuffer[2],4);
    Message((rand()%300)>>3<<3,(rand()%230)>>3<<3,messageMatrix[rand()&7],fxbuffer[3],8);
    /*Message((rand()%300),(rand()%230),"LjGP32",fxbuffer[1],12);
    Message((rand()%300),(rand()%230),"LjGP32",fxbuffer[2],13);
    Message((rand()%300),(rand()%230),"LjGP32",fxbuffer[3],14);  	*/
  }
  
  /*for (i=0;i<320;i++)
    for (j=0;j<240;j++) 
    {
    	(&gpDraw[nflip])->ptbuffer[(i*240+(239-j))]=((320-i+j)/3)+32;
    }*/
  
  Cls(0,0);
  Cls(0,1);
  GP_SetPal(1);     
        
  endl=pos+NB_LINE_SHOWN/2;  
  if (endl>MAXL) endl=MAXL;
  if (endl<NB_LINE_SHOWN) endl=NB_LINE_SHOWN;
  startl=endl-NB_LINE_SHOWN;
  if (startl<0) startl=0;

  while (GpKeyGet())
  {
  	__asm {nop;nop;nop;nop;}
  }
  
 
  fc=framecount;
  while (!choix)
  {
  	
  	while (framecount<fc)
  	{
#ifdef __GNUC__
  		asm volatile
	      (
	      	" nop\n"
	      	" nop\n"
	      	" nop\n"
	      	" nop\n"
	      );	 
#endif
  	}
  	fc++;
  	
  	for (i=0;i<320;i++)
    	for (j=0;j<240;j++) 
    	{
    		(&gpDraw[nflip])->ptbuffer[i*240+j]=fxbuffer[0][(i<<8)+((j+ypos[0])&0xff)]|\
    		fxbuffer[1][(i<<8)+((j+ypos[1])&0xff)]|\
    		fxbuffer[2][(i<<8)+((j+ypos[2])&0xff)]|\
    		fxbuffer[3][(i<<8)+((j+ypos[3])&0xff)];
    		
    	}
    	ypos[0]+=2+(fc&1);
    	ypos[1]+=2;
    	ypos[2]+=1+(fc&1);
    	ypos[3]+=1;
    	
  	
  	//do keyboard stuff 
  	if ((fc&3)==0)
  	{
  		GpKeyGetEx(&ExKey);
  	  	
  		if ((ExKey&GPC_VK_DOWN)&&(pos<MAXL))
  		{	
  			pos++;
  			if (pos>endl) 
  			{
  				endl++;
  				startl++;
  			}
  		}  			
  		if ((ExKey&GPC_VK_FR)&&(pos<MAXL))
  		{	
  			pos+=NB_LINE_SHOWN;
  			if (pos>MAXL) pos=MAXL;
  			if (pos>endl) 
  			{
  				endl=pos;
  				startl=endl-NB_LINE_SHOWN;
  				if (startl<0) startl=0;
  			}
  		}  			
  		if ((ExKey&GPC_VK_UP)&&(pos>0))
  		{
  			pos--;  	
  			if (pos<startl) 
  			{
  				endl--;
  				startl--;
  			}
  		}
  		if ((ExKey&GPC_VK_FL)&&(pos>0))
  		{
  			pos-=NB_LINE_SHOWN;  	
  			if (pos<0) pos=0;
  			if (pos<startl) 
  			{  				
  				startl=pos;  				
  				endl=startl+NB_LINE_SHOWN;
  				if (endl>MAXL) endl=MAXL;
  			}
  		}
  		if (ExKey&GPC_VK_FB) break;
  		
  	
  		// Save state nb
  		if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_Save)&&(savestateNb>0)) savestateNb--;
  	 	if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_Save)&&(savestateNb<9)) savestateNb++;
  	  	// Load state nb
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_Load)&&(loadstateNb>0)) loadstateNb--;
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_Load)&&(loadstateNb<9)) loadstateNb++;
  		// fskiprate
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_Fskip)&&(fskiprate>0)) fskiprate--;
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_Fskip)&&(fskiprate<10)) fskiprate++;  		
  		// fskiprate adj ratio
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_Fskipadj)&&(fskiprate_adj_ratio>0)) fskiprate_adj_ratio-=10;
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_Fskipadj)&&(fskiprate_adj_ratio<50)) fskiprate_adj_ratio+=10;
  		// pad mode
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_Pmode)&&(Vnes.var.padmode>0)) Vnes.var.padmode--;
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_Pmode)&&(Vnes.var.padmode<2)) Vnes.var.padmode++;  		
  		// AutoFire
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_AutoA)&&(Vnes.var.autofireA>0)) Vnes.var.autofireA--;
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_AutoA)&&(Vnes.var.autofireA<3)) Vnes.var.autofireA++;
  		if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_AutoB)&&(Vnes.var.autofireB>0)) Vnes.var.autofireB--;
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_AutoB)&&(Vnes.var.autofireB<3)) Vnes.var.autofireB++;
  		// gamma
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_Gamma)&&(gamma>0)) 
	  	{
	  		gamma--;
	  		GP_ReSetPalette();
	  		GP_SetPal(1);   
	  	}
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_Gamma)&&(gamma<9)) 
  		{
  			gamma++;
  			GP_ReSetPalette();
  			GP_SetPal(1);   
  		}
  		
  		if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_VideoMode)&&(Vnes.var.scaleMode>0)) 
  		{
  			Vnes.var.scaleMode--;
  			ppu_setscaleMode(Vnes.var.scaleMode);
  		}
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_VideoMode)&&(Vnes.var.scaleMode<1)) 
  		{
  			Vnes.var.scaleMode++;  		
  			ppu_setscaleMode(Vnes.var.scaleMode);
  		}
  		
  		// sound quality
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_SoundQuality)&&(Vnes.var.sndfreq>0)) 
	  	{
	  		Vnes.var.sndfreq--;
	  		Close_SoundSys();
	  		Open_SoundSys(Vnes.var.sndfreq,Vnes.var.sndfilter);
	  	}
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_SoundQuality)&&(Vnes.var.sndfreq<2)) 
  		{
  			Vnes.var.sndfreq++;
  			Close_SoundSys();
  			Open_SoundSys(Vnes.var.sndfreq,Vnes.var.sndfilter);  			
  		}
  		// sound filter
	  	if ((ExKey&GPC_VK_LEFT)&&(pos==GUI_SoundFilter)&&(Vnes.var.sndfilter>0)) 
	  	{
	  		Vnes.var.sndfilter--;
	  		switch (Vnes.var.sndfilter)
  			{
        			case 1:apu_setfilter(APU_FILTER_LOWPASS);break;
        			case 2:apu_setfilter(APU_FILTER_WEIGHTED);break;        			
        			default:apu_setfilter(APU_FILTER_NONE);        
        		}
        	}
	  		
  		if ((ExKey&GPC_VK_RIGHT)&&(pos==GUI_SoundFilter)&&(Vnes.var.sndfilter<2)) 
  		{
  			Vnes.var.sndfilter++;
  			switch (Vnes.var.sndfilter)
  			{
        			case 1:apu_setfilter(APU_FILTER_LOWPASS);break;
        			case 2:apu_setfilter(APU_FILTER_WEIGHTED);break;        			
        			default:apu_setfilter(APU_FILTER_NONE);        
        		}
        	}
  		
  		if ((ExKey&(GPC_VK_LEFT|GPC_VK_RIGHT))&&(pos==GUI_Sound)) Vnes.var.enablesound^=2;
  		
  		if ((ExKey&(GPC_VK_LEFT|GPC_VK_RIGHT))&&(pos==GUI_SprLimit)) Vnes.var.morethan8spr^=1;
  		
  		if ((ExKey&(GPC_VK_LEFT|GPC_VK_RIGHT))&&(pos==GUI_ShowFPS)) showFPS^=1;
  		
  		if ((ExKey&(GPC_VK_LEFT|GPC_VK_RIGHT))&&(pos==GUI_240lines)) Vnes.var.DrawAllLines^=1;
  		
  		if ((ExKey&(GPC_VK_LEFT|GPC_VK_RIGHT))&&(pos==GUI_VSync)) Vnes.var.vsync^=1;
  		
  	  	if (ExKey&GPC_VK_FA)
  		{
  		  if (pos==GUI_Browser) break;
  	   	  if (pos==GUI_Save) 
  	   	  {
  	   		nflip=0;
  			Cls(0,0);
  			Cls(0,1);  		
  			GpSurfaceSet(&gpDraw[nflip]);  			
  	   		if (!SaveStateSnss(savestateNb)) break;
  	   		break;
  	   	  }
  	   	  if (pos==GUI_Load) 
  	   	  {
  	   		nflip=0;
  			Cls(0,0);
  			Cls(0,1);  		
  			GpSurfaceSet(&gpDraw[nflip]);  			
  	   		if (!LoadStateSnss(loadstateNb)) break;
  	   	  }  	   	    	   	  
  	   	  /* RETURN*/
	   	  if (pos==GUI_Return) break;
	   	  /* RESET*/
	   	  if (pos==GUI_Reset) 
	   	  {
	   	  	nes_reset();
	   	  	break;
	   	  }
		  /* REBOOT */
	   	  if (pos==GUI_Reboot) 
	   	  {
	   	  	CloseAll();
	   	  	GpClockSpeedChange(67800000, 0x69032, 3); 
	   	  	GpAppExit();	   	  	
	   	  }

  		}  	  	
  	 }
  
  	
        for (i=startl;i<=endl;i++)        
        {
  	   if (i==pos) 
  	   {
  	   	gpprintf(8+2,(i-startl)*16+60+2,listeChoix[i],-1,-1,44);
  	   	gpprintf(8+1,(i-startl)*16+60+1,listeChoix[i],-1,-1,43);
  	   	gpprintf(8,(i-startl)*16+60,listeChoix[i],-1,-1,33);
  	   }
  	   else 
  	   {  	   	
  	   	gpprintf(8+1,(i-startl)*16+60+1,listeChoix[i],-1,-1,42);	   
  	   	gpprintf(8,(i-startl)*16+60,listeChoix[i],-1,-1,32);	   
  	   }
  	}
  	if ((pos==GUI_Save)||(pos==GUI_Load)||(pos==GUI_Gamma))
  	{
  	  switch (pos)
  	  {
  	  	case GUI_Save:k=savestateNb; break;
  	  	case GUI_Load:k=loadstateNb; break;  	  	
  	  	case GUI_Gamma:k=gamma; break;
  	  }  	  
  	  for (i=0;i<10;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(100+i*14,(pos-startl)*16+60,listestate[i],-1,-1,j);
  	  }
  	}
  	
  	if ((pos==GUI_Fskip))
  	{
  	  k=fskiprate;  	  
  	  for (i=0;i<11;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(100+i*14,(pos-startl)*16+60,listeFskip[i],-1,-1,j);
  	  }
  	}
  	
  	if ((pos==GUI_Fskipadj))
  	{
  	  k=fskiprate_adj_ratio/10;
  	  for (i=0;i<6;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(120+i*(8*3+6),(pos-startl)*16+60,listefskipadj[i],-1,-1,j);
  	  }
  	}
  	
  	if ((pos==GUI_Pmode))
  	{
  	  k=Vnes.var.padmode;
  	  for (i=0;i<3;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(100+i*(8*3+6),(pos-startl)*16+60,listepadmode[i],-1,-1,j);
  	  }
  	}
  	
  	if ((pos==GUI_SoundQuality))
  	{
  	  k=Vnes.var.sndfreq;
  	  for (i=0;i<3;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(120+i*(8*5+6),(pos-startl)*16+60,listeSndQuality[i],-1,-1,j);
  	  }
  	}
  	
  	if ((pos==GUI_SoundFilter))
  	{
  	  k=Vnes.var.sndfilter;
  	  for (i=0;i<3;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(120+i*(8*5+6),(pos-startl)*16+60,listeSndFilter[i],-1,-1,j);
  	  }
  	}
  	
  	if ((pos==GUI_AutoA)||(pos==GUI_AutoB))
  	{
  	  switch (pos)
  	  {
  	  	case GUI_AutoA:k=Vnes.var.autofireA;break;
  	  	case GUI_AutoB:k=Vnes.var.autofireB;break;
  	  }
  	  for (i=0;i<4;i++)
  	  {
  	    if (i==k) j=35;
  	    else j=34;
  	    gpprintf(100+i*(8*4+6),(pos-startl)*16+60,listeAutoMode[i],-1,-1,j);
  	  }
  	}
  	
  	if (pos==GUI_VideoMode)
  	{  	  
  	  k=90;
  	  for (i=0;i<2/*5*/;i++)
  	  {
  	    if (i==Vnes.var.scaleMode) j=35;
  	    else j=34;
  	    gpprintf(k,(pos-startl)*16+60,scaleMode[i],-1,-1,j);
  	    k+=strlen(scaleMode[i])*8+8;
  	  }
  	}
  	
  	
  	
  	if ((pos==GUI_Sound)||(pos==GUI_SprLimit)||(pos==GUI_ShowFPS)||(pos==GUI_240lines)||(pos==GUI_VSync))  	
  	{
  	  switch (pos)
  	  {
  	  	case GUI_Sound:k=Vnes.var.enablesound; break;
  	  	case GUI_SprLimit:k=Vnes.var.morethan8spr; break;  	  	
  	  	case GUI_ShowFPS:k=showFPS; break;  	  	
  	  	case GUI_240lines:k=Vnes.var.DrawAllLines; break;  	  	
  	  	case GUI_VSync:k=Vnes.var.vsync; break;  	  	
  	  }  	  
  	  
  	  gpprintf(150+14,(pos-startl)*16+60,"ON",-1,-1,34+(k!=0));
  	  gpprintf(150+45,(pos-startl)*16+60,"OFF",-1,-1,35-(k!=0));
  	  
  	}
  	
  	gm_sprintf(chaine,"[LJGP32] 0.3\nmem : %d",gm_availablesize());
  	gpprintf(8+2,16+2,chaine,-1,-1,37);  	
  	gpprintf(8,16,chaine,-1,-1,36);
  	
  	if (strlen(gamename)>22)
  	{
  		j=strlen(gamename)-22;
  		i=(fc>>3)%(2*j+2);
  		if (i>j) i=2*j+1-i;  		
  	}
  	else i=0;
  	gm_sprintf(chaine,"%.22s\nmap%03d/%s/%s",gamename+i,Vnes.Mapper_used,Vnes.var.country,Vnes.var.publisher);
  	gpprintf(130+2,16+2,chaine,-1,-1,39);
  	gpprintf(130,16,chaine,-1,-1,38);
  	
  	gpprintf(1,220,helpText[pos],-1,-1,36);
  	
  	if (startl>0) gpprintf(16,45,"<- scroll up (L)->",-1,-1,64+((fc>>1)&0x1f));
  	if (endl<MAXL) gpprintf(16,60+(NB_LINE_SHOWN+1)*16,"<- scroll down (R)->",-1,-1,64+((fc>>1)&0x1f));
  	
  	GpSurfaceFlip(&gpDraw[nflip++]);
  	nflip&=1;
  	
  	
   }  	
   validate=(ExKey&GPC_VK_FA);
   do
   {
   	GpKeyGetEx(&ExKey);
   }
   while (ExKey);
   framecount=fc;
  
   Cls(0,0);
   Cls(0,1);   
   GP_SetPal(0);
   Cls(13,0);
   Cls(13,1);   
   nflip=0;
   
   GpSurfaceSet(&gpDraw[nflip]);
   
   gm_free(fxbuffer[0]);
   gm_free(fxbuffer[1]);
   gm_free(fxbuffer[2]);
   gm_free(fxbuffer[3]);
   
   if ((pos==GUI_Browser)&&validate) return 1; //exit current rom
   return 0;
}
